/*
 *  MICO --- an Open Source CORBA implementation
 *  Copyright (c) 1997-2006 by The Mico Team
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#include <CORBA.h>
#include <mico/throw.h>

#ifndef __REGISTRY_SERVICE_H__
#define __REGISTRY_SERVICE_H__






namespace tecgraf
{
namespace openbus
{
namespace core
{
namespace v1_05
{
namespace registry_service
{

class IRegistryService;
typedef IRegistryService *IRegistryService_ptr;
typedef IRegistryService_ptr IRegistryServiceRef;
typedef ObjVar< IRegistryService > IRegistryService_var;
typedef ObjOut< IRegistryService > IRegistryService_out;

class IManagement;
typedef IManagement *IManagement_ptr;
typedef IManagement_ptr IManagementRef;
typedef ObjVar< IManagement > IManagement_var;
typedef ObjOut< IManagement > IManagement_out;

}
}
}
}
}



#include <core.h>
#include <access_control_service.h>
#include <scs.h>



namespace tecgraf
{
namespace openbus
{
namespace core
{
namespace v1_05
{
namespace registry_service
{

typedef StringSequenceTmpl<CORBA::String_var> PropertyValue;
typedef TSeqVar< StringSequenceTmpl<CORBA::String_var> > PropertyValue_var;
typedef TSeqOut< StringSequenceTmpl<CORBA::String_var> > PropertyValue_out;

struct Property;
typedef TVarVar< Property > Property_var;
typedef TVarOut< Property > Property_out;


struct Property {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef Property_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Property();
  ~Property();
  Property( const Property& s );
  Property& operator=( const Property& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var name;
  PropertyValue value;
};

typedef SequenceTmpl< Property,MICO_TID_DEF> PropertyList;
typedef TSeqVar< SequenceTmpl< Property,MICO_TID_DEF> > PropertyList_var;
typedef TSeqOut< SequenceTmpl< Property,MICO_TID_DEF> > PropertyList_out;

struct ServiceOffer;
typedef TVarVar< ServiceOffer > ServiceOffer_var;
typedef TVarOut< ServiceOffer > ServiceOffer_out;


struct ServiceOffer {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef ServiceOffer_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  ServiceOffer();
  ~ServiceOffer();
  ServiceOffer( const ServiceOffer& s );
  ServiceOffer& operator=( const ServiceOffer& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  PropertyList properties;
  ::scs::core::IComponent_var member;
};

typedef SequenceTmpl< ServiceOffer,MICO_TID_DEF> ServiceOfferList;
typedef TSeqVar< SequenceTmpl< ServiceOffer,MICO_TID_DEF> > ServiceOfferList_var;
typedef TSeqOut< SequenceTmpl< ServiceOffer,MICO_TID_DEF> > ServiceOfferList_out;

typedef char* RegistryIdentifier;
typedef CORBA::String_var RegistryIdentifier_var;
typedef CORBA::String_out RegistryIdentifier_out;

typedef char* Facet;
typedef CORBA::String_var Facet_var;
typedef CORBA::String_out Facet_out;

typedef StringSequenceTmpl<CORBA::String_var> FacetList;
typedef TSeqVar< StringSequenceTmpl<CORBA::String_var> > FacetList_var;
typedef TSeqOut< StringSequenceTmpl<CORBA::String_var> > FacetList_out;

struct ServiceOfferEntry;
typedef TVarVar< ServiceOfferEntry > ServiceOfferEntry_var;
typedef TVarOut< ServiceOfferEntry > ServiceOfferEntry_out;


struct ServiceOfferEntry {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef ServiceOfferEntry_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  ServiceOfferEntry();
  ~ServiceOfferEntry();
  ServiceOfferEntry( const ServiceOfferEntry& s );
  ServiceOfferEntry& operator=( const ServiceOfferEntry& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  ServiceOffer aServiceOffer;
  access_control_service::Credential aCredential;
  RegistryIdentifier_var identifier;
  CORBA::String_var authorizedFacets;
  PropertyList properties;
};

typedef SequenceTmpl< ServiceOfferEntry,MICO_TID_DEF> ServiceOfferEntryList;
typedef TSeqVar< SequenceTmpl< ServiceOfferEntry,MICO_TID_DEF> > ServiceOfferEntryList_var;
typedef TSeqOut< SequenceTmpl< ServiceOfferEntry,MICO_TID_DEF> > ServiceOfferEntryList_out;

struct UnathorizedFacets : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  UnathorizedFacets();
  ~UnathorizedFacets();
  UnathorizedFacets( const UnathorizedFacets& s );
  UnathorizedFacets& operator=( const UnathorizedFacets& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  #ifndef HAVE_EXPLICIT_STRUCT_OPS
  UnathorizedFacets();
  #endif //HAVE_EXPLICIT_STRUCT_OPS
  UnathorizedFacets( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& _m0 );

  #ifdef HAVE_STD_EH
  UnathorizedFacets *operator->() { return this; }
  UnathorizedFacets& operator*() { return *this; }
  operator UnathorizedFacets*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static UnathorizedFacets *_downcast( CORBA::Exception *ex );
  static const UnathorizedFacets *_downcast( const CORBA::Exception *ex );
  FacetList facets;
};

#ifdef HAVE_STD_EH
typedef UnathorizedFacets UnathorizedFacets_catch;
#else
typedef ExceptVar< UnathorizedFacets > UnathorizedFacets_var;
typedef TVarOut< UnathorizedFacets > UnathorizedFacets_out;
typedef UnathorizedFacets_var UnathorizedFacets_catch;
#endif // HAVE_STD_EH

struct ServiceOfferNonExistent : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  ServiceOfferNonExistent();
  ~ServiceOfferNonExistent();
  ServiceOfferNonExistent( const ServiceOfferNonExistent& s );
  ServiceOfferNonExistent& operator=( const ServiceOfferNonExistent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  ServiceOfferNonExistent *operator->() { return this; }
  ServiceOfferNonExistent& operator*() { return *this; }
  operator ServiceOfferNonExistent*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static ServiceOfferNonExistent *_downcast( CORBA::Exception *ex );
  static const ServiceOfferNonExistent *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef ServiceOfferNonExistent ServiceOfferNonExistent_catch;
#else
typedef ExceptVar< ServiceOfferNonExistent > ServiceOfferNonExistent_var;
typedef TVarOut< ServiceOfferNonExistent > ServiceOfferNonExistent_out;
typedef ServiceOfferNonExistent_var ServiceOfferNonExistent_catch;
#endif // HAVE_STD_EH


/*
 * Base class and common definitions for interface IRegistryService
 */

class IRegistryService : 
  virtual public CORBA::Object
{
  public:
    virtual ~IRegistryService();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef IRegistryService_ptr _ptr_type;
    typedef IRegistryService_var _var_type;
    #endif

    static IRegistryService_ptr _narrow( CORBA::Object_ptr obj );
    static IRegistryService_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static IRegistryService_ptr _duplicate( IRegistryService_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static IRegistryService_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual char* _cxx_register( const ::tecgraf::openbus::core::v1_05::registry_service::ServiceOffer& aServiceOffer ) = 0;
    virtual CORBA::Boolean unregister( const char* identifier ) = 0;
    virtual void update( const char* identifier, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& newProperties ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* find( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* findByCriteria( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferEntryList* localFind( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria ) = 0;

  protected:
    IRegistryService() {};
  private:
    IRegistryService( const IRegistryService& );
    void operator=( const IRegistryService& );
};

// Stub for interface IRegistryService
class IRegistryService_stub:
  virtual public IRegistryService
{
  public:
    virtual ~IRegistryService_stub();
    char* _cxx_register( const ::tecgraf::openbus::core::v1_05::registry_service::ServiceOffer& aServiceOffer );
    CORBA::Boolean unregister( const char* identifier );
    void update( const char* identifier, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& newProperties );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* find( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* findByCriteria( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferEntryList* localFind( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria );

  private:
    void operator=( const IRegistryService_stub& );
};

#ifndef MICO_CONF_NO_POA

class IRegistryService_stub_clp :
  virtual public IRegistryService_stub,
  virtual public PortableServer::StubBase
{
  public:
    IRegistryService_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~IRegistryService_stub_clp ();
    char* _cxx_register( const ::tecgraf::openbus::core::v1_05::registry_service::ServiceOffer& aServiceOffer );
    CORBA::Boolean unregister( const char* identifier );
    void update( const char* identifier, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& newProperties );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* find( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* findByCriteria( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferEntryList* localFind( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria );

  protected:
    IRegistryService_stub_clp ();
  private:
    void operator=( const IRegistryService_stub_clp & );
};

#endif // MICO_CONF_NO_POA

typedef char* InterfaceIdentifier;
typedef CORBA::String_var InterfaceIdentifier_var;
typedef CORBA::String_out InterfaceIdentifier_out;

typedef StringSequenceTmpl<CORBA::String_var> InterfaceIdentifierList;
typedef TSeqVar< StringSequenceTmpl<CORBA::String_var> > InterfaceIdentifierList_var;
typedef TSeqOut< StringSequenceTmpl<CORBA::String_var> > InterfaceIdentifierList_out;

struct InterfaceIdentifierInUse : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InterfaceIdentifierInUse();
  ~InterfaceIdentifierInUse();
  InterfaceIdentifierInUse( const InterfaceIdentifierInUse& s );
  InterfaceIdentifierInUse& operator=( const InterfaceIdentifierInUse& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InterfaceIdentifierInUse *operator->() { return this; }
  InterfaceIdentifierInUse& operator*() { return *this; }
  operator InterfaceIdentifierInUse*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InterfaceIdentifierInUse *_downcast( CORBA::Exception *ex );
  static const InterfaceIdentifierInUse *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InterfaceIdentifierInUse InterfaceIdentifierInUse_catch;
#else
typedef ExceptVar< InterfaceIdentifierInUse > InterfaceIdentifierInUse_var;
typedef TVarOut< InterfaceIdentifierInUse > InterfaceIdentifierInUse_out;
typedef InterfaceIdentifierInUse_var InterfaceIdentifierInUse_catch;
#endif // HAVE_STD_EH

struct InterfaceIdentifierNotFound : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InterfaceIdentifierNotFound();
  ~InterfaceIdentifierNotFound();
  InterfaceIdentifierNotFound( const InterfaceIdentifierNotFound& s );
  InterfaceIdentifierNotFound& operator=( const InterfaceIdentifierNotFound& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InterfaceIdentifierNotFound *operator->() { return this; }
  InterfaceIdentifierNotFound& operator*() { return *this; }
  operator InterfaceIdentifierNotFound*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InterfaceIdentifierNotFound *_downcast( CORBA::Exception *ex );
  static const InterfaceIdentifierNotFound *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InterfaceIdentifierNotFound InterfaceIdentifierNotFound_catch;
#else
typedef ExceptVar< InterfaceIdentifierNotFound > InterfaceIdentifierNotFound_var;
typedef TVarOut< InterfaceIdentifierNotFound > InterfaceIdentifierNotFound_out;
typedef InterfaceIdentifierNotFound_var InterfaceIdentifierNotFound_catch;
#endif // HAVE_STD_EH

struct InterfaceIdentifierNonExistent : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InterfaceIdentifierNonExistent();
  ~InterfaceIdentifierNonExistent();
  InterfaceIdentifierNonExistent( const InterfaceIdentifierNonExistent& s );
  InterfaceIdentifierNonExistent& operator=( const InterfaceIdentifierNonExistent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InterfaceIdentifierNonExistent *operator->() { return this; }
  InterfaceIdentifierNonExistent& operator*() { return *this; }
  operator InterfaceIdentifierNonExistent*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InterfaceIdentifierNonExistent *_downcast( CORBA::Exception *ex );
  static const InterfaceIdentifierNonExistent *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InterfaceIdentifierNonExistent InterfaceIdentifierNonExistent_catch;
#else
typedef ExceptVar< InterfaceIdentifierNonExistent > InterfaceIdentifierNonExistent_var;
typedef TVarOut< InterfaceIdentifierNonExistent > InterfaceIdentifierNonExistent_out;
typedef InterfaceIdentifierNonExistent_var InterfaceIdentifierNonExistent_catch;
#endif // HAVE_STD_EH

struct InterfaceIdentifierAlreadyExists : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InterfaceIdentifierAlreadyExists();
  ~InterfaceIdentifierAlreadyExists();
  InterfaceIdentifierAlreadyExists( const InterfaceIdentifierAlreadyExists& s );
  InterfaceIdentifierAlreadyExists& operator=( const InterfaceIdentifierAlreadyExists& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InterfaceIdentifierAlreadyExists *operator->() { return this; }
  InterfaceIdentifierAlreadyExists& operator*() { return *this; }
  operator InterfaceIdentifierAlreadyExists*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InterfaceIdentifierAlreadyExists *_downcast( CORBA::Exception *ex );
  static const InterfaceIdentifierAlreadyExists *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InterfaceIdentifierAlreadyExists InterfaceIdentifierAlreadyExists_catch;
#else
typedef ExceptVar< InterfaceIdentifierAlreadyExists > InterfaceIdentifierAlreadyExists_var;
typedef TVarOut< InterfaceIdentifierAlreadyExists > InterfaceIdentifierAlreadyExists_out;
typedef InterfaceIdentifierAlreadyExists_var InterfaceIdentifierAlreadyExists_catch;
#endif // HAVE_STD_EH

enum AuthorizationType {
  ATUser = 0,
  ATSystemDeployment
};

typedef AuthorizationType& AuthorizationType_out;

struct Authorization;
typedef TVarVar< Authorization > Authorization_var;
typedef TVarOut< Authorization > Authorization_out;


struct Authorization {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef Authorization_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  Authorization();
  ~Authorization();
  Authorization( const Authorization& s );
  Authorization& operator=( const Authorization& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  CORBA::String_var id;
  AuthorizationType type;
  InterfaceIdentifierList authorized;
};

typedef SequenceTmpl< Authorization,MICO_TID_DEF> AuthorizationList;
typedef TSeqVar< SequenceTmpl< Authorization,MICO_TID_DEF> > AuthorizationList_var;
typedef TSeqOut< SequenceTmpl< Authorization,MICO_TID_DEF> > AuthorizationList_out;

struct ServiceOfferInterface;
typedef TVarVar< ServiceOfferInterface > ServiceOfferInterface_var;
typedef TVarOut< ServiceOfferInterface > ServiceOfferInterface_out;


struct ServiceOfferInterface {
  #ifdef HAVE_TYPEDEF_OVERLOAD
  typedef ServiceOfferInterface_var _var_type;
  #endif
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  ServiceOfferInterface();
  ~ServiceOfferInterface();
  ServiceOfferInterface( const ServiceOfferInterface& s );
  ServiceOfferInterface& operator=( const ServiceOfferInterface& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS

  RegistryIdentifier_var id;
  CORBA::String_var member;
  InterfaceIdentifierList interfaces;
};

typedef SequenceTmpl< ServiceOfferInterface,MICO_TID_DEF> ServiceOfferInterfaceList;
typedef TSeqVar< SequenceTmpl< ServiceOfferInterface,MICO_TID_DEF> > ServiceOfferInterfaceList_var;
typedef TSeqOut< SequenceTmpl< ServiceOfferInterface,MICO_TID_DEF> > ServiceOfferInterfaceList_out;

struct MemberNonExistent : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  MemberNonExistent();
  ~MemberNonExistent();
  MemberNonExistent( const MemberNonExistent& s );
  MemberNonExistent& operator=( const MemberNonExistent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  MemberNonExistent *operator->() { return this; }
  MemberNonExistent& operator*() { return *this; }
  operator MemberNonExistent*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static MemberNonExistent *_downcast( CORBA::Exception *ex );
  static const MemberNonExistent *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef MemberNonExistent MemberNonExistent_catch;
#else
typedef ExceptVar< MemberNonExistent > MemberNonExistent_var;
typedef TVarOut< MemberNonExistent > MemberNonExistent_out;
typedef MemberNonExistent_var MemberNonExistent_catch;
#endif // HAVE_STD_EH

struct AuthorizationNonExistent : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  AuthorizationNonExistent();
  ~AuthorizationNonExistent();
  AuthorizationNonExistent( const AuthorizationNonExistent& s );
  AuthorizationNonExistent& operator=( const AuthorizationNonExistent& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  AuthorizationNonExistent *operator->() { return this; }
  AuthorizationNonExistent& operator*() { return *this; }
  operator AuthorizationNonExistent*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static AuthorizationNonExistent *_downcast( CORBA::Exception *ex );
  static const AuthorizationNonExistent *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef AuthorizationNonExistent AuthorizationNonExistent_catch;
#else
typedef ExceptVar< AuthorizationNonExistent > AuthorizationNonExistent_var;
typedef TVarOut< AuthorizationNonExistent > AuthorizationNonExistent_out;
typedef AuthorizationNonExistent_var AuthorizationNonExistent_catch;
#endif // HAVE_STD_EH

struct InvalidRegularExpression : public CORBA::UserException {
  #ifdef HAVE_EXPLICIT_STRUCT_OPS
  InvalidRegularExpression();
  ~InvalidRegularExpression();
  InvalidRegularExpression( const InvalidRegularExpression& s );
  InvalidRegularExpression& operator=( const InvalidRegularExpression& s );
  #endif //HAVE_EXPLICIT_STRUCT_OPS


  #ifdef HAVE_STD_EH
  InvalidRegularExpression *operator->() { return this; }
  InvalidRegularExpression& operator*() { return *this; }
  operator InvalidRegularExpression*() { return this; }
  #endif // HAVE_STD_EH

  void _throwit() const;
  const char *_repoid() const;
  void _encode( CORBA::DataEncoder &en ) const;
  void _encode_any( CORBA::Any &a ) const;
  CORBA::Exception *_clone() const;
  static InvalidRegularExpression *_downcast( CORBA::Exception *ex );
  static const InvalidRegularExpression *_downcast( const CORBA::Exception *ex );
};

#ifdef HAVE_STD_EH
typedef InvalidRegularExpression InvalidRegularExpression_catch;
#else
typedef ExceptVar< InvalidRegularExpression > InvalidRegularExpression_var;
typedef TVarOut< InvalidRegularExpression > InvalidRegularExpression_out;
typedef InvalidRegularExpression_var InvalidRegularExpression_catch;
#endif // HAVE_STD_EH


/*
 * Base class and common definitions for interface IManagement
 */

class IManagement : 
  virtual public CORBA::Object
{
  public:
    virtual ~IManagement();

    #ifdef HAVE_TYPEDEF_OVERLOAD
    typedef IManagement_ptr _ptr_type;
    typedef IManagement_var _var_type;
    #endif

    static IManagement_ptr _narrow( CORBA::Object_ptr obj );
    static IManagement_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static IManagement_ptr _duplicate( IManagement_ptr _obj )
    {
      CORBA::Object::_duplicate (_obj);
      return _obj;
    }

    static IManagement_ptr _nil()
    {
      return 0;
    }

    virtual void *_narrow_helper( const char *repoid );

    virtual void addInterfaceIdentifier( const char* ifaceId ) = 0;
    virtual void removeInterfaceIdentifier( const char* ifaceId ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList* getInterfaceIdentifiers() = 0;
    virtual void grant( const char* id, const char* ifaceId, CORBA::Boolean strict ) = 0;
    virtual void revoke( const char* id, const char* ifaceId ) = 0;
    virtual void removeAuthorization( const char* id ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::Authorization* getAuthorization( const char* id ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizations() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizationsByInterfaceId( const ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList& ifaceIds ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfaces() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfacesByMember( const char* member ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfaces() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfacesByMember( const char* member ) = 0;
    virtual CORBA::Boolean unregister( const char* id ) = 0;

  protected:
    IManagement() {};
  private:
    IManagement( const IManagement& );
    void operator=( const IManagement& );
};

// Stub for interface IManagement
class IManagement_stub:
  virtual public IManagement
{
  public:
    virtual ~IManagement_stub();
    void addInterfaceIdentifier( const char* ifaceId );
    void removeInterfaceIdentifier( const char* ifaceId );
    ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList* getInterfaceIdentifiers();
    void grant( const char* id, const char* ifaceId, CORBA::Boolean strict );
    void revoke( const char* id, const char* ifaceId );
    void removeAuthorization( const char* id );
    ::tecgraf::openbus::core::v1_05::registry_service::Authorization* getAuthorization( const char* id );
    ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizations();
    ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizationsByInterfaceId( const ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList& ifaceIds );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfaces();
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfacesByMember( const char* member );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfaces();
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfacesByMember( const char* member );
    CORBA::Boolean unregister( const char* id );

  private:
    void operator=( const IManagement_stub& );
};

#ifndef MICO_CONF_NO_POA

class IManagement_stub_clp :
  virtual public IManagement_stub,
  virtual public PortableServer::StubBase
{
  public:
    IManagement_stub_clp (PortableServer::POA_ptr, CORBA::Object_ptr);
    virtual ~IManagement_stub_clp ();
    void addInterfaceIdentifier( const char* ifaceId );
    void removeInterfaceIdentifier( const char* ifaceId );
    ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList* getInterfaceIdentifiers();
    void grant( const char* id, const char* ifaceId, CORBA::Boolean strict );
    void revoke( const char* id, const char* ifaceId );
    void removeAuthorization( const char* id );
    ::tecgraf::openbus::core::v1_05::registry_service::Authorization* getAuthorization( const char* id );
    ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizations();
    ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizationsByInterfaceId( const ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList& ifaceIds );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfaces();
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfacesByMember( const char* member );
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfaces();
    ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfacesByMember( const char* member );
    CORBA::Boolean unregister( const char* id );

  protected:
    IManagement_stub_clp ();
  private:
    void operator=( const IManagement_stub_clp & );
};

#endif // MICO_CONF_NO_POA

}
}
}
}
}


#ifndef MICO_CONF_NO_POA



namespace POA_tecgraf
{
namespace openbus
{
namespace core
{
namespace v1_05
{
namespace registry_service
{

class IRegistryService : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~IRegistryService ();
    tecgraf::openbus::core::v1_05::registry_service::IRegistryService_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static IRegistryService * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual char* _cxx_register( const ::tecgraf::openbus::core::v1_05::registry_service::ServiceOffer& aServiceOffer ) = 0;
    virtual CORBA::Boolean unregister( const char* identifier ) = 0;
    virtual void update( const char* identifier, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& newProperties ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* find( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferList* findByCriteria( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferEntryList* localFind( const ::tecgraf::openbus::core::v1_05::registry_service::FacetList& facets, const ::tecgraf::openbus::core::v1_05::registry_service::PropertyList& criteria ) = 0;

  protected:
    IRegistryService () {};

  private:
    IRegistryService (const IRegistryService &);
    void operator= (const IRegistryService &);
};

class IManagement : virtual public PortableServer::StaticImplementation
{
  public:
    virtual ~IManagement ();
    tecgraf::openbus::core::v1_05::registry_service::IManagement_ptr _this ();
    bool dispatch (CORBA::StaticServerRequest_ptr);
    virtual void invoke (CORBA::StaticServerRequest_ptr);
    virtual CORBA::Boolean _is_a (const char *);
    virtual CORBA::InterfaceDef_ptr _get_interface ();
    virtual CORBA::RepositoryId _primary_interface (const PortableServer::ObjectId &, PortableServer::POA_ptr);

    virtual void * _narrow_helper (const char *);
    static IManagement * _narrow (PortableServer::Servant);
    virtual CORBA::Object_ptr _make_stub (PortableServer::POA_ptr, CORBA::Object_ptr);

    virtual void addInterfaceIdentifier( const char* ifaceId ) = 0;
    virtual void removeInterfaceIdentifier( const char* ifaceId ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList* getInterfaceIdentifiers() = 0;
    virtual void grant( const char* id, const char* ifaceId, CORBA::Boolean strict ) = 0;
    virtual void revoke( const char* id, const char* ifaceId ) = 0;
    virtual void removeAuthorization( const char* id ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::Authorization* getAuthorization( const char* id ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizations() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::AuthorizationList* getAuthorizationsByInterfaceId( const ::tecgraf::openbus::core::v1_05::registry_service::InterfaceIdentifierList& ifaceIds ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfaces() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getOfferedInterfacesByMember( const char* member ) = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfaces() = 0;
    virtual ::tecgraf::openbus::core::v1_05::registry_service::ServiceOfferInterfaceList* getUnauthorizedInterfacesByMember( const char* member ) = 0;
    virtual CORBA::Boolean unregister( const char* id ) = 0;

  protected:
    IManagement () {};

  private:
    IManagement (const IManagement &);
    void operator= (const IManagement &);
};

}
}
}
}
}


#endif // MICO_CONF_NO_POA

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_Property;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_ServiceOffer;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_ServiceOfferEntry;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_UnathorizedFacets;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_ServiceOfferNonExistent;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_IRegistryService;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_InterfaceIdentifierInUse;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_InterfaceIdentifierNotFound;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_InterfaceIdentifierNonExistent;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_InterfaceIdentifierAlreadyExists;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_AuthorizationType;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_Authorization;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_ServiceOfferInterface;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_MemberNonExistent;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_AuthorizationNonExistent;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_InvalidRegularExpression;

extern CORBA::StaticTypeInfo *_marshaller_tecgraf_openbus_core_v1_05_registry_service_IManagement;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_core_v1_05_registry_service_Property;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_core_v1_05_registry_service_ServiceOffer;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_core_v1_05_registry_service_ServiceOfferEntry;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_core_v1_05_registry_service_Authorization;

extern CORBA::StaticTypeInfo *_marshaller__seq_tecgraf_openbus_core_v1_05_registry_service_ServiceOfferInterface;

#endif
